#include "testlib.h"
#include <vector>

using namespace std;

using ll = long long;

const ll VAL = 1'000'000'000'000'000'000;
const ll N = 4 * VAL;
const ll N_ARRAY = 200'000;

int readAns(InStream& stream, ll a, ll b, int t) {
    ll n;
    if (t == 0) {
        n = stream.readLong(2, N, "n");
    } else {
        n = stream.readLong(2, N_ARRAY, "n");
        vector<ll> arr(n);
        for (int i = 0; i < n; ++i) {
            arr[i] = stream.readLong(-VAL, VAL, "a_i");
        }
        ll sum_max = 0, sum_min = 0;
        if (n == 1) {
            sum_max = sum_min = arr[0];
        } else {
            for (int i = 0; i < n; ++i) {
                if (abs(arr[i] - arr[(i + 1) % n]) != 1) {
                    stream.quitf(_wa, "sequence is incorrect, cur = %lld, next = %lld", arr[i], arr[(i + 1) % n]);
                }
                if (arr[i] > arr[(i + 1) % n] && arr[i] > arr[(i - 1 + n) % n]) {
                    sum_max += arr[i];
                }
                if (arr[i] < arr[(i + 1) % n] && arr[i] < arr[(i - 1 + n) % n]) {
                    sum_min += arr[i];
                }
            }
        }
        if (sum_max != a) {
            stream.quitf(_wa, "sequence is incorrect, A = %lld, sum_local_max = %lld", a, sum_max);
        }
        if (sum_min != b) {
            stream.quitf(_wa, "sequence is incorrect, B = %lld, sum_local_min = %lld", b, sum_min);
        }
    }
    return n;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    ll a = inf.readLong();
    ll b = inf.readLong();
    int t = inf.readInt(0, 1);

    ll jans = readAns(ans, a, b, t);
    ll pans = readAns(ouf, a, b, t);
    
    if (pans == jans) {
        quitf(_ok, "n = %lld", jans);
    } else if (t == 0) {
        quitf(_wa, "participant has different n: jans = %lld, pans = %lld\n", jans, pans);
    } else {
        quitf(_fail, "participant has different n: jans = %lld, pans = %lld\n", jans, pans);
    }
}
