#include "testlib.h"

using namespace std;

using ll = long long;

const int delta = 100'000;
const ll VAL = 1'000'000'000'000'000'000;
//                      0    1          2     3
const ll MinVal[6] = {-VAL, -100'000, -VAL, -VAL};
const ll MaxVal[6] = { VAL,  100'000,  VAL,  VAL};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int gr_n = validator.group().empty() ? 0 : atoi(validator.group().c_str());

    ll a = inf.readLong(MinVal[gr_n], MaxVal[gr_n], "A");
    inf.readEoln();
    ll b = inf.readLong(MinVal[gr_n], MaxVal[gr_n], "B");
    inf.readEoln();

    ensuref(b < a, "B must be less than A");

    int t = inf.readInt(0, 1, "t");
    inf.readEoln();
    inf.readEof();

    if (t == 1) {
        ensuref(a - b <= delta, "Sequence is too long");
    }

    if (gr_n == 1) {
        ensuref(b <= 0 && 0 <= a, "0 must be in [B; A]");
    }
    if (gr_n == 2) {
        ensuref(t == 0, "t must be 0");
    }
}
