#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int wnext = 0;

int my_rand(int mx){
    return rnd.wnext(mx, wnext);
}

void random_generator(int n){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
        swap(a[i], a[my_rand(i + 1)]);
    }
    cout << n << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
}

void only_one_extremum(int n){
    vector<int> a, b;
    for(int i=1; i<=n; i++){
        if(my_rand(2) == 1){
            a.push_back(i);
        } else{
            b.push_back(i);
        }
    }
    reverse(b.begin(), b.end());
    if(my_rand(2) == 1){
        swap(a, b);
    }
    cout << n << endl;
    if(a.size() == n || b.size() == n){
        if(a.size() < b.size())
            swap(a, b);
        for(int i=0; i<n; i++){
            cout << a[i] << " \n"[i == n - 1];
        }
    } else{
        for(int i=0; i<a.size(); i++){
            cout << a[i] << " ";
        }
        for(int i=0; i<b.size(); i++){
            cout << b[i] << " \n"[i == b.size() - 1];
        }
    }
}

void only_two_extremums(int n){
    vector<int> a(n);
    for(int i=1; i<=n; i++){
        a[i - 1] = i;
    }
    int pos1 = my_rand(n);
    int pos2 = my_rand(n + 1);
    if(pos1 > pos2)
        swap(pos1, pos2);
    reverse(a.begin() + pos1, a.begin() + pos2);
    cout << n << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
}

void only_one_swap(int n){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
    }
    int pos = my_rand(n - 1);
    swap(a[pos], a[pos + 1]);
    cout << n << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n-1];
    }
}

void only_two_swaps(int n){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
    }
    int pos = my_rand(n - 1);
    int pos2 = my_rand(n - 1);
    if(pos == pos2){
        if(pos == 0){
            pos2 += 2;
        } else{
            pos2 -= 2;
        }
    }
    swap(a[pos], a[pos + 1]);
    swap(a[pos2], a[pos2 + 1]);
    cout << n << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n-1];
    }
}

void trivial(int n){
    cout << n << "\n";
    for (int i = 1; i <= n; i++) {
        cout << i << " \n"[i == n];
    }
}

void trivial_reverse(int n){
    cout << n << "\n";
    for (int i = n; i >= 1; i--){
        cout << i << " \n"[i == 1];
    }
}

signed main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    
    string mode = opt<string>("mode");
    int n = opt<int>("n");
    wnext = opt<int>("wnext", 0);
    
    if (mode == "random") {
        random_generator(n);
    } else if (mode == "only_one_extremum") {
        only_one_extremum(n);
    } else if(mode == "only_one_swap") {
        only_one_swap(n);
    } else if(mode == "trivial") {
        trivial(n);
    } else if(mode == "trivial_reverse") {
        trivial_reverse(n);
    } else if(mode == "only_two_swaps") {
        only_two_swaps(n);
    } else if(mode == "only_two_extremums"){
        only_two_extremums(n);
    }
    return 0;
}

