// #include "/home/tikhon/Downloads/testlib-master/testlib.h"
#include "testlib.h"

#include <bits/stdc++.h>
using namespace std;

#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
map<string, string> params;

vector<string> mods = {"rand", "under", "ower", "under_ower", "ower_under", "k2_all", "k2_not_all_easy", "k2_not_all_hard", "k2_a_2...n-1"};
string mode = "any";

// единственное, что по сути меняется нежду тестами - распределение a[i]
// k во всех тестах - просто равноменро в доступном диапазоне.

// need a good k=2 generation

vector<int> under(int n, int up) {
    // like 1 1 1 2 2 4 7
    vector<int> res(n);
    double l = log(up);
    for (int i = 0; i < n; ++i) {
        double r = rnd.next(0.0, l);
        res[i] = (int)(round(exp(r)));
    }
    return res;
}
vector<int> ower(int n, int up) {
    // like 1 3 5 5 6 6 7
    vector<int> res = under(n, up);
    for (int i = 0; i < n; ++i) {
        res[i] = up - res[i] + 1;
    }
    return res;
}

vector<int> concat(vector<int> l, vector<int> r, int shift) {
    for (int x : r) {
        l.push_back(x + shift);
    }
    return l;
}

void gen(int n, int q, int k, int max_a, vector<int>& a, vector<int>& ask) {
    a.resize(n, 1);  // 1...n

    if (mode == "rand") {
        for (int i = 0; i < n; ++i)
            a[i] = rnd.next(1, max_a);
    }

    if (mode == "ower") {
        a = ower(n, max_a);
    }
    if (mode == "under") {
        a = under(n, max_a);
    }

    if (mode == "under_ower") {
        int r = rnd.next(n / 3, 2 * n / 3);
        a = concat(under(r, (long long)r * max_a / n), ower(n - r, (long long)(n - r) * max_a / n), (long long)r * max_a / n);
    }

    if (mode == "ower_under") {
        int r = rnd.next(n / 3, 2 * n / 3);
        a = concat(ower(r, (long long)r * max_a / n), under(n - r, (long long)(n - r) * max_a / n), (long long)r * max_a / n);
    }

    if (mode == "k2_all") {
        // untrivial split, that gives full
        // need a[n-1-a[n-1]] > n-1-a[n-1]
        // need a[n-1] < n-1

        int r = n / 3; // rnd.next(2, n/2 - 2);  // first a[r-1] <= r
        a[r - 1] = r;
        for (int i = 0; i < r-1; ++i) a[i] = rnd.next(i+2, r);
        a[n - 1] = n - r - 2;
        a[r] = r + 2;
        a[r + 1] = r + 3;
        for (int i = r + 2; i < n - 1; ++i) a[i] = rnd.next(r+3, a[n - 1]);
    }

    if (mode == "k2_not_all_easy") {
        // a[n-1] >= n-1 => ans = cnt(<=n-1)

        int r = min(n / 2, 14);
        for (int i = 0; i < n - r - 2; ++i) {
            a[i] = rnd.next(1, i + 2);
        }
        a[n - r - 2] = n - 1;
        a[n - r - 1] = n - 1;
        for (int i = n - r; i < n; ++i) {
            a[i] = n;
        }
    }

    if (mode == "k2_not_all_hard") {
        // tests like [3 3 4 4 4 4] - not a split, that gives full => ans = n-1
        int r = n / 3;

        a[n-1] = n - r;
        for (int i = 0; i < r; ++i) {
            a[i] = rnd.next(i + 2, min(r + 1, i + 6));
        }
        for (int i = r; i < n - 1; ++i) {
            a[i] = max(r + 1, min(r + 1 + (i - r) / 2 + rnd.next(-3, 2), n - r));
        }
    }

    if (mode == "k2_a_2...n-1") {
        a[0] = 2;
        for (int i = 0; i < n; ++i) {
            a[i] = rnd.next(2, n-1);
        }
        a[n-1] = n-1;
    }

    ask.resize(q);  // 2..k
    if (q == 1) {
        ask[0] = k;
    } else {
        for (int i = 0; i < q; ++i) {
            ask[i] = (long long)(k - 2) * i / (q - 1) + 2;
        }        
    }

    // sort(all(a));
    // reverse(all(a));
    shuffle(all(a));
    shuffle(all(ask));
}


int main(int argc, char* argv[]){
    registerGen(argc, argv, 1);

    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        }
    }


    int n = stoi(params["n"]);
    int q = stoi(params["q"]);

    int max_k = n;
    if (params.count("k")) max_k = stoi(params["k"]);

    int max_a = n;
    if (params.count("a")) max_a = stoi(params["a"]);
    

    if (params.count("mode"))
        mode = params["mode"];
    if (mode == "any")
        mode = rnd.any(mods);

    vector<int> a, ask;
    gen(n, q, max_k, max_a, a, ask);

    cout << n << '\n';
    cout << a[0];
    for (int i = 1; i < n; ++i) {
        cout << ' ' << a[i];
    }
    cout << '\n';
    cout << q << '\n';
    for (int i = 0; i < q; ++i) {
        cout << ask[i] << '\n';
    }

    return 0;
}
