#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int wnext = 0;

int my_rand(int mx){
    return rnd.wnext(mx, wnext);
}

void full_random(int n, int q, int segment_size, int eq_len){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
        swap(a[i], a[rnd.next(i + 1)]);
    }
    cout << n << " " << q << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
    for(int i=0; i<q; i++){
        if(segment_size == -1){
            int a = rnd.next(n - 2);
            int b = rnd.next(n - 2);
            if(a > b)
                swap(a, b);
            cout << a + 1 << " " << b + 3 << "\n";
        } else{
            int sz = i % (segment_size - 1) + 2;
            if(eq_len)
                sz = segment_size;
            int a = my_rand(n - sz + 1);
            int b = a + sz - 1;
            cout << a + 1 << " " << b + 1 << "\n";
        }
    }
}

void regular_perm(int n, int q, int segment_size, int eq_len){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
    }
    cout << n << " " << q << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
    for(int i=0; i<q; i++){
        if(segment_size == -1){
            int a = rnd.next(n - 2);
            int b = rnd.next(n - 2);
            if(a > b)
                swap(a, b);
            cout << a + 1 << " " << b + 3 << "\n";
        } else{
            int sz = i % (segment_size - 1) + 2;
            if(eq_len)
                sz = segment_size;
            int a = my_rand(n - sz + 1);
            int b = a + sz - 1;
            cout << a + 1 << " " << b + 1 << "\n";
        }
    }
}

void equal_by_mod(int n, int q, int segment_size, int mod, int eq_len){
    cout << n << " " << q << "\n";
    int cnt = 0;
    for(int i=0; i<mod; ++i){
        vector<int> a;
        for(int j=i; j<n; j+=mod){
            a.push_back(j);
            swap(a[a.size() - 1], a[rnd.next(a.size())]);
        }
        for(int j:a){
            cnt++;
            cout << j + 1 << " \n"[cnt == n];
        }
    }
    for(int i=0; i<q; i++){
        if(segment_size == -1){
            int a = rnd.next(n - 2);
            int b = rnd.next(n - 2);
            if(a > b)
                swap(a, b);
            cout << a + 1 << " " << b + 3 << "\n";
        } else{
            int sz = i % (segment_size - 1) + 2;
            if(eq_len)
                sz = segment_size;
            int a = my_rand(n - sz + 1);
            int b = a + sz - 1;
            cout << a + 1 << " " << b + 1 << "\n";
        }
    }
}

void antimo(int n, int q, int k){
    vector<int> a(n);
    for(int i=0; i<n; i++){
        a[i] = i + 1;
        swap(a[i], a[rnd.next(i + 1)]);
    }
    vector<pair<int, int>> posts;
    for(int i=0; i<n; i+=k){
        for(int j=i + k; j<n; j+=k){
            int l = rnd.next(i, min(n - 1, i + k - 1));
            int r = rnd.next(j, min(n - 1, j + k - 1));
            posts.push_back(make_pair(l, r));
        }
        if(posts.size() > q)
            break;
    }
    if(posts.size() < q){
        q = posts.size();
    }
    cout << n << " " << q << endl;
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
    for(int i=0; i<q; i++){
        cout << posts[i].first + 1 << " " << posts[i].second + 1 << endl;
    }
}

void antimo2(int n, int q, int k){
    vector<int> a;
    vector<bool> used(n + 1);
    int cur = n - k - 1;
    int cnt = 0;
    for(int i=0; i<k; i++){
        a.push_back(cur);
        used[cur] = true;
        assert(cur >= 1);
        cur -= k + 2;
    }
    used[n] = true;
    a.push_back(n);
    for(int i=n; i>=1; i--){
        if(!used[i]){
            a.push_back(i);
        }
    }
    reverse(a.begin(), a.end());
    cout << n << " " << q << "\n";
    for(int i=0; i<n; i++){
        cout << a[i] << " \n"[i == n - 1];
    }
    cout << n - k << " " << n << endl;
    for(int i=1; i<q; i++){
        int a = rnd.next(n - 2);
        int b = rnd.next(n - 2);
        if(a > b)
            swap(a, b);
        cout << a + 1 << " " << b + 3 << "\n";
    }
}

signed main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    
    string mode = opt<string>("mode");
    string perm_mode = opt<string>("permutation_mode", "standartr");
    string segments_mode = opt<string>("segments_mode", "standart");
    int n = opt<int>("n");
    int q = opt<int>("q");
    int k = opt<int>("k", 600);
    int mod = opt<int>("mod", 1);
    int eq_len = opt<int>("eq_len", 0);
    int segment_size = opt<int>("segment_size", -1);
    wnext = opt<int>("wnext", 0);
    
    if(mode == "full_random"){
        full_random(n, q, segment_size, eq_len);
    } else if(mode == "regular_perm"){
        regular_perm(n, q, segment_size, eq_len);
    } else if(mode == "equal_by_mod"){
        equal_by_mod(n, q, segment_size, mod, eq_len);
    } else if(mode == "antimo"){
        antimo(n, q, k);
    } else if(mode == "antimo2"){
        antimo2(n, q, k);
    }
    
    return 0;
}
