#include "bits/stdc++.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define repr(i, n) for(int i = (n - 1); i >= 0; --i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using pi = pair<int, int>;

const int INFi = 2e9;
const ll INF = 2e18;
const int maxN = 6e5;

inline int64_t hilbertOrder(int x, int y, int pow, int rotate) {
    if (pow == 0) {
        return 0;
    }
    int hpow = 1 << (pow - 1);
    int seg = (x < hpow) ? (
            (y < hpow) ? 0 : 3
    ) : (
                      (y < hpow) ? 1 : 2
              );
    seg = (seg + rotate) & 3;
    const int rotateDelta[4] = {3, 0, 0, 1};
    int nx = x & (x ^ hpow), ny = y & (y ^ hpow);
    int nrot = (rotate + rotateDelta[seg]) & 3;
    int64_t subSquareSize = int64_t(1) << (2 * pow - 2);
    int64_t ans = seg * subSquareSize;
    int64_t add = hilbertOrder(nx, ny, pow - 1, nrot);
    ans += (seg == 1 || seg == 2) ? add : (subSquareSize - add - 1);
    return ans;
}

struct fenwick {
    vector<int> fenw;
    int n;
    int l;

    void build(int k) {
        n = k;
        l = 1;
        while((1 << l) <= n) l++;
        l--;
        fenw.resize(n);
    }

    void upd(int i, int x) {
        for (; i < n; i = i | (i + 1)) fenw[i] += x;
    }

    int get(int i) {
        int r = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) r += fenw[i];
        return r;
    }

    int lower_bound(int x) {
        int i = -1;
        for(int j = l; j >= 0; --j) {
            int r = i + int(1 << j);
            if (r < n && fenw[r] < x) {
                i = r;
                x -= fenw[i];
            }
        }
        return i + 1;
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    vi a(n);
    rep(i, n) cin >> a[i];
    vi l(q), r(q);
    rep(i, q) {
        cin >> l[i] >> r[i];
        l[i]--;
        r[i]--;
    }
    vl h(q);
    rep(i, q) h[i] = hilbertOrder(l[i], r[i], 20, 0);
    vi ord(q);
    iota(all(ord), 0);
    sort(all(ord), [&](const int &i, const int &j) {
        return h[i] < h[j];
    });
    fenwick f;
    fenwick fr;
    f.build(n + 1);
    fr.build(n + 1);
    auto add = [&] (int x) {
        f.upd(x, 1);
        int r = f.get(x);
        int nxt = f.lower_bound(r + 1);
        int prv = f.lower_bound(r - 1);
        if (prv != 0 && nxt != n + 1) {
            fr.upd(nxt - prv, -1);
        }
        if (nxt != n + 1) fr.upd(nxt - x, 1);
        if (prv != 0) fr.upd(x - prv, 1);
    };
    auto del = [&] (int x) {
        int r = f.get(x);
        int nxt = f.lower_bound(r + 1);
        int prv = f.lower_bound(r - 1);
        if (prv != 0 && nxt != n + 1) fr.upd(nxt - prv, 1);
        if (nxt != n + 1) fr.upd(nxt - x, -1);
        if (prv != 0) fr.upd(x - prv, -1);
        f.upd(x, -1);
    };
    int L = 0;
    int R = -1;
    vi ans(q);
    for (auto &i: ord) {
        while(R < r[i]) add(a[++R]);
        while(L > l[i]) add(a[--L]);
        while(R > r[i]) del(a[R--]);
        while(L < l[i]) del(a[L++]);
        ans[i] = fr.lower_bound(1);
    }
    rep(i, q) cout << ans[i] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    rep(_, t) {
        solve();
    }
    return 0;
}