#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
//#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int k = 550;
const int maxn = 1e6 + 1e5;

inline int smallest_bit(int a) {
    return __builtin_ctz(a);
}

inline int biggest_bit(int a) {
    return 31 - __builtin_clz(a);
}

struct Bitset {
    vector<int> bits;
    short bit, cur;

    Bitset(int n) {
        bits.assign((n + 30) / 31, 0);
    }

    void change(int &pos) {
        bit = pos / 31;
        bits[bit] ^= (1 << (pos - bit * 31));
    }

    void set_zero() {
        for (auto &i: bits)
            i = 0;
    }

    inline int get_left(int &pos, int &range) {
        bit = pos / 31;
        cur = pos - bit * 31;
        if (cur && (bits[bit] & ((1 << cur) - 1))) {
            return bit * 31 + biggest_bit(bits[bit] & ((1 << cur) - 1));
        } else {
            for (bit = bit - 1; bit >= 0 && cur < range; --bit) {
                if (bits[bit]) {
                    return bit * 31 + biggest_bit(bits[bit]);
                }
                cur += 31;
            }
        }
        return -maxn;
    }

    inline int get_right(int &pos, int &range) {
        bit = pos / 31;
        cur = pos - bit * 31;
        if (bits[bit] >> cur) {
            return pos + smallest_bit(bits[bit] >> cur);
        } else {
            cur = 30 - cur;
            for (bit = bit + 1; bit < bits.size() && cur < range; ++bit) {
                if (bits[bit]) {
                    return smallest_bit(bits[bit]) + bit * 31;
                }
                cur += 31;
            }
        }
        return maxn;
    }
};

Bitset kek = Bitset(k);
int n, q;
int answer[k][k];
short Max[k][k];
short Min[k][k];
short Left[maxn];
short Right[maxn];
pair<int, int> posts[maxn];
int answers_for_posts[maxn];
int last[maxn];

inline void build_segment(vector<pair<int, int>> &a) {
    int pnt = 0;
    int i, j;
    vector<bool> used(k + 1, false);
    for (i = 0; i < maxn; i++) {
        Left[i] = pnt;
        if (pnt < k && a[pnt].second == i) {
            ++pnt;
        }
    }
    pnt = k - 1;
    for (i = maxn - 1; i >= 0; i--) {
        Right[i] = pnt;
        if (pnt >= 0 && a[pnt].second == i) {
            --pnt;
        }
    }
    for (i = 0; i < q; ++i) {
        used[Left[posts[i].first]] = true;
    }
    int ans;
    for (i = 0; i < k; ++i) {
        if (!used[i])
            continue;
        kek.set_zero();
        ans = k;
        for (j = i; j < k; ++j) {
            ans = min(ans, a[j].first - kek.get_left(a[j].first, ans));
            ans = min(ans, kek.get_right(a[j].first, ans) - a[j].first);
            kek.change(a[j].first);
            ::answer[i][j] = ans;
        }
    }
    int mx, mn;
    for (i = 0; i < k; ++i) {
        mn = n, mx = 0;
        for (j = i; j < k; ++j) {
            mx = max(mx, a[j].first);
            mn = min(mn, a[j].first);
            Max[i][j] = mx;
            Min[i][j] = mn;
        }
    }
    for (i = 0; i < q; i++) {
        if (answers_for_posts[i] > 1) {
            if (Left[posts[i].first] <= Right[posts[i].second] && last[i] != 228) {
                answers_for_posts[i] = min(answers_for_posts[i],
                                           Min[Left[posts[i].first]][Right[posts[i].second]] - last[i]);
            }
            if (Left[posts[i].first] <= Right[posts[i].second]) {
                last[i] = Max[Left[posts[i].first]][Right[posts[i].second]] - k;
                if (Left[posts[i].first] < Right[posts[i].second]) {
                    answers_for_posts[i] = min(answers_for_posts[i],
                                               answer[Left[posts[i].first]][Right[posts[i].second]]);
                }
            } else if (last[i] != 228) {
                last[i] -= k;
            }
        }
    }
}

bool cmp(pii a, pii b) {
    if (a.first / k == b.first / k) {
        return a.second < b.second;
    }
    return a.first < b.first;
}

void solve() {
    cin >> n >> q;
    vector<int> a(n);
    a.reserve(n + k);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    while (n % k != 0) {
        a.push_back(n + 1);
        ++n;
    }

    for (int i = 0; i < q; i++) {
        cin >> posts[i].first >> posts[i].second;
        posts[i].first--;
        posts[i].second--;
    }

    for (int i = 0; i < q; i++) {
        last[i] = 228;
        answers_for_posts[i] = n;
    }
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        b[i] = {a[i] - 1, i};
    }

    sort(all(b), cmp);
    vector<pair<int, int>> c;

    for (int i = 0; i < n; i += k) {
        for (int j = i; j < i + k; ++j) {
            c.emplace_back(b[j].first - i, b[j].second);
        }
        build_segment(c);
        c.clear();
    }

    for (int i = 0; i < q; i++) {
        cout << answers_for_posts[i] << endl;
    }
}

/*
5 3
2 1 4 5 3
2 3
1 3
4 5
 */

signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
