#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <tuple>
#include <math.h>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <queue>
#include <random>
#include <array>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <unordered_map>

#define DEBUG
#define pqueue priority_queue
#define pb(x) push_back(x)
#define endl '\n'
#define all(x) x.begin(), x.end()
//#define int long long
#define mk(a, b) make_pair(a, b)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;
typedef vector<ull> vull;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef vector<pair<int, int> > vpii;
typedef pair<ll, ll> pll;
typedef vector<bool> vb;
typedef vector<string> vs;
typedef vector<vector<int> > vvi;
typedef vector<char> vc;

const ll inf = 1e9 + 228;
const ll infll = 1e18;
const int mod = 1e9 + 7;
const ll mod3 = 1e9 + 7;
const ld eps = 1e-7;
const ll mod2 = 1e9 + 9;
const ld PI = atan2l(0, -1);

void fast_io() {
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int n, q;

const int maxn = 100000;
int k = 800;

int cnt_diffs[maxn + 1];
set<int> diffs;
set<int> num;

inline void add_diffs(int a){
    ++cnt_diffs[a];
    if(cnt_diffs[a] == 1){
        diffs.insert(a);
    }
}

inline void del_diffs(int a){
    --cnt_diffs[a];
    if(!cnt_diffs[a]){
        diffs.erase(a);
    }
}

inline void add(int a) {
    num.insert(a);
    auto it = num.find(a);
    if (num.size() == 1)
        return;
    if (it == num.begin()) {
        auto it2 = it;
        ++it2;
        add_diffs(*it2 - *it);
    } else if (it == --num.end()) {
        auto it2 = it;
        --it2;
        add_diffs(*it - *it2);
    } else {
        auto it2 = it;
        ++it;
        --it2;
        del_diffs(*it - *it2);
        ++it2;
        add_diffs(*it - *it2);
        --it2;
        --it;
        add_diffs(*it - *it2);
    }
}

inline void del(int a) {
    auto it = num.find(a);
    if (num.size() == 1){
        num.erase(a);
        return;
    }
    if (it == num.begin()) {
        auto it2 = it;
        it2++;
        del_diffs(*it2 - *it);
    } else if (it == --num.end()) {
        auto it2 = it;
        it2--;
        del_diffs(*it - *it2);
    } else {
        auto it2 = it;
        it++;
        it2--;
        add_diffs(*it - *it2);
        it2++;
        del_diffs(*it - *it2);
        it2--;
        it--;
        del_diffs(*it - *it2);
    }
    num.erase(a);
}

bool cmp(vi &a, vi &b) {
    if (a[0] / k == b[0] / k) {
        return a[1] < b[1];
    }
    return a[0] < b[0];
}

void solve() {
    cin >> n >> q;
    vector<int> a(n);
    a.reserve(n + k);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    while (n % k != 0) {
        a.push_back(n + 1);
        ++n;
    }
    vector<vector<int>> posts(q, vector<int>(3));
    for (int i = 0; i < q; i++) {
        cin >> posts[i][0] >> posts[i][1];
        posts[i][2] = i;
        posts[i][0]--;
        posts[i][1]--;
    }

    sort(all(posts), cmp);
    int pnt_l = 0, pnt_r = 0;
    add(a[0]);
    diffs.insert(n);
    vector<int> answer(q);
    for (int i = 0; i < q; i++) {
        while (pnt_l > posts[i][0])
            add(a[--pnt_l]);
        while (pnt_r < posts[i][1])
            add(a[++pnt_r]);
        while (pnt_r > posts[i][1])
            del(a[pnt_r--]);
        while (pnt_l < posts[i][0])
            del(a[pnt_l++]);
        answer[posts[i][2]] = *diffs.begin();
    }
    for(int i=0; i<q; i++){
         cout << answer[i] << endl;
    }

}

/*
5 3
2 1 4 5 3
2 3
1 3
4 5
 */

signed main() {
    fast_io();
    int q = 1;
//    cin >> q;
    while (q--)
        solve();
    return 0;
}
